package org.gcube.dataanalysis.executor.rscripts;

import java.io.File;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import org.gcube.dataanalysis.ecoengine.datatypes.PrimitiveType;
import org.gcube.dataanalysis.ecoengine.datatypes.StatisticalType;
import org.gcube.dataanalysis.ecoengine.datatypes.enumtypes.PrimitiveTypes;
import org.gcube.dataanalysis.executor.rscripts.generic.GenericRScript;
import org.gcube.dataanalysis.ecoengine.utils.DynamicEnum;
import java.lang.reflect.Field;

public class LasVegas extends GenericRScript {

	static class opIO2338bd6ce4b9f46d9a3f4d5d7ea4bbe38 extends DynamicEnum {
		public enum EopIO2338bd6ce4b9f46d9a3f4d5d7ea4bbe38 {};
		public Field[] getFields() {
			Field[] fields = EopIO2338bd6ce4b9f46d9a3f4d5d7ea4bbe38.class.getDeclaredFields();
			return fields;
		}
	}

	@Override
	public String getDescription() {
		return "Las Vegas Casino";
	}

	protected void initVariables(){
		mainScriptName="LasVegas/Main.R";
		packageURL="http://data.d4science.org/cHUybzdFWHV0MkZMZzYydnA2NXFzcDYyYStQZDRNN1dHbWJQNStIS0N6Yz0";
		environmentalvariables = new ArrayList<String>();
		inputvariables.add("classToRun");
		inputvariables.add("game");
		inputvariables.add("bets");
		inputvariables.add("bluff");
		outputvariables.add("result");
	}

	@Override
	protected void setInputParameters() {
		inputs.add(new PrimitiveType(String.class.getName(), null,PrimitiveTypes.STRING, "classToRun", "Casino main class", "org.myfactory.specialgroup.Casino"));
		if (org.gcube.dataanalysis.executor.rscripts.LasVegas.opIO2338bd6ce4b9f46d9a3f4d5d7ea4bbe38.EopIO2338bd6ce4b9f46d9a3f4d5d7ea4bbe38.values().length==0){
			opIO2338bd6ce4b9f46d9a3f4d5d7ea4bbe38 en = new opIO2338bd6ce4b9f46d9a3f4d5d7ea4bbe38();
			en.addEnum(org.gcube.dataanalysis.executor.rscripts.LasVegas.opIO2338bd6ce4b9f46d9a3f4d5d7ea4bbe38.EopIO2338bd6ce4b9f46d9a3f4d5d7ea4bbe38.class, "slots");
			en.addEnum(org.gcube.dataanalysis.executor.rscripts.LasVegas.opIO2338bd6ce4b9f46d9a3f4d5d7ea4bbe38.EopIO2338bd6ce4b9f46d9a3f4d5d7ea4bbe38.class, "roulette");
			en.addEnum(org.gcube.dataanalysis.executor.rscripts.LasVegas.opIO2338bd6ce4b9f46d9a3f4d5d7ea4bbe38.EopIO2338bd6ce4b9f46d9a3f4d5d7ea4bbe38.class, "poker");
		}

		addEnumerateInput(org.gcube.dataanalysis.executor.rscripts.LasVegas.opIO2338bd6ce4b9f46d9a3f4d5d7ea4bbe38.EopIO2338bd6ce4b9f46d9a3f4d5d7ea4bbe38.values(), "game", "Game to play", "slots");
		inputs.add(new PrimitiveType(File.class.getName(), null,PrimitiveTypes.FILE, "bets", "Bets", "bets.txt"));
		inputs.add(new PrimitiveType(Boolean.class.getName(), null,PrimitiveTypes.BOOLEAN, "bluff", "Bluff", "false"));
	}

	@Override
	public StatisticalType getOutput() {
		output.put("result",new PrimitiveType(File.class.getName(), new File(outputValues.get("result")), PrimitiveTypes.FILE, "result", "result"));
		PrimitiveType o = new PrimitiveType(LinkedHashMap.class.getName(), output, PrimitiveTypes.MAP, "Output", "");
		return o;
	}
}
